diff --git a/test/regress_bufferevent.c b/test/regress_bufferevent.c
index 5e48a7ccd..989778d98 100644
--- a/test/regress_bufferevent.c
+++ b/test/regress_bufferevent.c
@@ -276,13 +276,14 @@ static int trace_lock_unlock(unsigned mode, void *lock_)
 }
 static void lock_unlock_free_thread_cbs(void)
 {
+	/** drop immutable flag */
+	evthread_set_lock_callbacks(NULL);
+
 	event_base_free(NULL);
 
 	if (libevent_tests_running_in_debug_mode)
 		libevent_global_shutdown();
 
-	/** drop immutable flag */
-	evthread_set_lock_callbacks(NULL);
 	/** avoid calling of event_global_setup_locks_() for new cbs */
 	libevent_global_shutdown();
 	/** drop immutable flag for non-debug ops (since called after shutdown) */
